"""The code is divided into two files. The main:py file defines the main menu which offers two types of information
labeled as ”Available World Maps by year:” and ”Country info available per year:”. Both labels and the buttons
below each are generated by the tkinter and grouped as f father. The FunctionsClasses:py
file includes the function and classes which are called from the main:py file. For details read README_PROJECT.pdf
Data sources: https://ourworldindata.org/renewable-energy
CODED by Joaquin Miranda. VERSION 17.02.2022, 23 Hrs"""

import tkinter as tk
from FuntionsClasses import mapp, Curves

#   Added for tk
root = tk.Tk()
root.title("Renewable Energies Report")

"""The first type of information under ”Available World Maps by year:” menu is provided by the four buttons, ”Total
Energy from Renewables”, ”Energy from Photovoltaic”, ”Hydropower Generation”, ”Wind Power Generation”.
The four lists folders; tittles; tochange; colors are all of size four and contain the arguments which are passing
to the mapp function throughout the tk option command with the lambda option. Additionally one has to
provide the argument f_father, since the function mapp will create a child from out from these tk buttons. """

# Lists with info for the mapp function which create the maps.
titles = ['Share of Primary Energy from Renewable Sources (%) ', 'Photovoltaic Capacity in (GW) ',
          'Hydropower Generation in (TWh) ', 'Wind Power Generation in (TWh) ']
tochanges = ['Renewables (% sub energy)', 'Solar Capacity', 'Electricity from hydro (TWh)',
             'Electricity from wind (TWh)']
colors = ['Greens', 'Reds', 'Blues', 'Greys']
folders = ["/renewable-share-energy", "/PV-generation", "/hydropower-generation", "/wind-generation"]


f_father = tk.Frame(root)
f_father.grid(row=0, column=0, sticky=tk.E + tk.W)  # Main menu with buttons (Father)

# Buttons for the maps
label1 = tk.Label(f_father, bg="green", text="Available World Maps by year:")
label1.grid(row=1, column=0, sticky=tk.E + tk.W, ipadx=32)
b0 = tk.Button(f_father, text="Total Energy from Renewables", command=lambda: mapp(folders[0], titles[0],
                                                                                   tochanges[0], colors[0], f_father))
b0.bind("<Button-2>", lambda event: mapp(folders[0], titles[0], tochanges[0], colors[0], f_father))
b0.grid(row=2, column=0, sticky=tk.E + tk.W, ipadx=32)
b1 = tk.Button(f_father, text="Energy from Photovoltaic", command=lambda: mapp(folders[1], titles[1],
                                                                                tochanges[1], colors[1], f_father))
b1.bind("<Button-2>", lambda event: mapp(folders[1], titles[1], tochanges[1], colors[1], f_father))
b1.grid(row=3, column=0, sticky=tk.E + tk.W, ipadx=32)
b2 = tk.Button(f_father, text="Hydropower Generation", command=lambda: mapp(folders[2], titles[2],
                                                                            tochanges[2], colors[2], f_father))
b2.bind("<Button-2>", lambda event: mapp(folders[2], titles[2], tochanges[2], colors[2], f_father))
b2.grid(row=4, column=0, sticky=tk.E + tk.W, ipadx=32)
b3 = tk.Button(f_father, text="Wind Power Generation", command=lambda: mapp(folders[3], titles[3],
                                                                            tochanges[3], colors[3], f_father))
b3.bind("<Button-2>", lambda event: mapp(folders[3], titles[3],
                                         tochanges[3], colors[3], f_father))
b3.grid(row=5, column=0, sticky=tk.E + tk.W, ipadx=32)

"""The second type of information under ”Country info available per year:” is provided by the buttons ”Photovoltaic
Consumption by Countries”, ”Windpower Generation by Countries”, ”Biofuel Production by Countries”, and
”Hydropower Generation by Countries”."""

# Lists with info for the Curves class which create the curves for each country.
files = ["solar-energy-consumption.csv", "cumulative-installed-wind-energy-capacity-gigawatts.csv",
         "biofuel-production.csv", "hydropower-consumption.csv"]
toplots = ["Electricity from solar", "Wind Capacity", "Biofuels Production - TWh - Total",
           "Electricity from hydro (TWh)"]
ylabels = ["Electricity from Solar Energy (TWh)", "Electricity from Wind Power (TWh)", "Biofuel Production (TWh)",
           "Hydropower Consumption (TWh)"]

# Buttons for the curves
label2 = tk.Label(f_father, bg="yellow", text="Country info available per year:")
label2.grid(row=6, column=0, sticky=tk.E + tk.W, ipadx=32)

b4 = tk.Button(f_father, text="Photovoltaic Consumption by Countries", command=lambda: Curves(files[0],
                                                                                               toplots[0], ylabels[0]))
b4.bind("<Button-2>", lambda event: Curves(files[0], toplots[0], ylabels[0]))
b4.grid(row=7, column=0, sticky=tk.E + tk.W, ipadx=32)

b5 = tk.Button(f_father, text="Windpower Generation by Countries", command=lambda: Curves(files[1],
                                                                                          toplots[1], ylabels[1]))
b5.bind("<Button-2>", lambda event: Curves(files[1], toplots[1], ylabels[1]))
b5.grid(row=8, column=0, sticky=tk.E + tk.W, ipadx=32)

b6 = tk.Button(f_father, text="Biofuel Production by Countries", command=lambda: Curves(files[2],
                                                                                        toplots[2], ylabels[2]))
b6.bind("<Button-2>", lambda event: Curves(files[2], toplots[2], ylabels[2]))
b6.grid(row=10, column=0, sticky=tk.E + tk.W, ipadx=32)

b7 = tk.Button(f_father, text="Hydropower Generation by Countries", command=lambda: Curves(files[3],
                                                                                           toplots[3], ylabels[3]))
b7.bind("<Button-2>", lambda event: Curves(files[4], toplots[4], ylabels[4]))
b7.grid(row=9, column=0, sticky=tk.E + tk.W, ipadx=32)

# Closing Button
b8 = tk.Button(f_father, text="  Quit  ", command=root.destroy)
b8.grid(row=11, column=0, sticky=tk.E + tk.W, ipadx=32)

root.mainloop()
